/**
 ******************************************************************************
 * @addtogroup UAVObjects OpenPilot UAVObjects
 * @{ 
 * @addtogroup AttitudeDesired AttitudeDesired 
 * @brief The desired attitude that @ref StabilizationModule will try and achieve if FlightMode is Stabilized.  Comes from @ref ManaulControlModule.
 *
 * Autogenerated files and functions for AttitudeDesired Object
 
 * @{ 
 *
 * @file       attitudedesired.h
 * @author     The OpenPilot Team, http://www.openpilot.org Copyright (C) 2010.
 * @brief      Implementation of the AttitudeDesired object. This file has been 
 *             automatically generated by the UAVObjectGenerator.
 * 
 * @note       Object definition file: attitudedesired.xml. 
 *             This is an automatically generated file.
 *             DO NOT modify manually.
 *
 * @see        The GNU Public License (GPL) Version 3
 *
 *****************************************************************************/
/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
 * for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */

#ifndef ATTITUDEDESIRED_H
#define ATTITUDEDESIRED_H

// Object constants
#define ATTITUDEDESIRED_OBJID 1412270808U
#define ATTITUDEDESIRED_NAME "AttitudeDesired"
#define ATTITUDEDESIRED_METANAME "AttitudeDesiredMeta"
#define ATTITUDEDESIRED_ISSINGLEINST 1
#define ATTITUDEDESIRED_ISSETTINGS 0
#define ATTITUDEDESIRED_NUMBYTES sizeof(AttitudeDesiredData)

// Object access macros
/**
 * @function AttitudeDesiredGet(dataOut)
 * @brief Populate a AttitudeDesiredData object
 * @param[out] dataOut 
 */
#define AttitudeDesiredGet(dataOut) UAVObjGetData(AttitudeDesiredHandle(), dataOut)
#define AttitudeDesiredSet(dataIn) UAVObjSetData(AttitudeDesiredHandle(), dataIn)
#define AttitudeDesiredInstGet(instId, dataOut) UAVObjGetInstanceData(AttitudeDesiredHandle(), instId, dataOut)
#define AttitudeDesiredInstSet(instId, dataIn) UAVObjSetInstanceData(AttitudeDesiredHandle(), instId, dataIn)
#define AttitudeDesiredConnectQueue(queue) UAVObjConnectQueue(AttitudeDesiredHandle(), queue, EV_MASK_ALL_UPDATES)
#define AttitudeDesiredConnectCallback(cb) UAVObjConnectCallback(AttitudeDesiredHandle(), cb, EV_MASK_ALL_UPDATES)
#define AttitudeDesiredCreateInstance() UAVObjCreateInstance(AttitudeDesiredHandle())
#define AttitudeDesiredRequestUpdate() UAVObjRequestUpdate(AttitudeDesiredHandle())
#define AttitudeDesiredRequestInstUpdate(instId) UAVObjRequestInstanceUpdate(AttitudeDesiredHandle(), instId)
#define AttitudeDesiredUpdated() UAVObjUpdated(AttitudeDesiredHandle())
#define AttitudeDesiredInstUpdated(instId) UAVObjUpdated(AttitudeDesiredHandle(), instId)
#define AttitudeDesiredGetMetadata(dataOut) UAVObjGetMetadata(AttitudeDesiredHandle(), dataOut)
#define AttitudeDesiredSetMetadata(dataIn) UAVObjSetMetadata(AttitudeDesiredHandle(), dataIn)
#define AttitudeDesiredReadOnly(dataIn) UAVObjReadOnly(AttitudeDesiredHandle())

// Object data
typedef struct {
    float Roll;
    float Pitch;
    float Yaw;
    float Throttle;

} __attribute__((packed)) AttitudeDesiredData;

// Field information
// Field Roll information
// Field Pitch information
// Field Yaw information
// Field Throttle information


// Generic interface functions
int32_t AttitudeDesiredInitialize();
UAVObjHandle AttitudeDesiredHandle();

#endif // ATTITUDEDESIRED_H

/**
 * @}
 * @}
 */
